<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "language".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Language".
 *
 * Columns in table "language" available as properties of the model,
 * followed by relations of table "language" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $primary
 *
 * @property PracticeLanguage[] $practiceLanguages
 * @property ProviderLanguage[] $providerLanguages
 */
abstract class BaseLanguage extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'language';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Language|Languages', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('primary', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 50),
            array('primary', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, primary', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practiceLanguages' => array(self::HAS_MANY, 'PracticeLanguage', 'language_id'),
            'providerLanguages' => array(self::HAS_MANY, 'ProviderLanguage', 'language_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'primary' => Yii::t('app', 'Primary'),
            'practiceLanguages' => null,
            'providerLanguages' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('primary', $this->primary);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
